﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Silverlight.Chart;
using System.ComponentModel;

namespace WebChartAxisRanges
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent(); 

        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            (Resources["vm"] as MainViewModel).ChangeData();
        }
    }

    public class MainViewModel : INotifyPropertyChanged
    {

        public MainViewModel()
        {
            Data = new List<Data> 
            {
                new Data { X = 5, Y = 10, R = 1 },
                new Data { X = 1, Y = 9, R = 2  },
                new Data { X = 2, Y = 8, R = 7 },
                new Data { X = 3, Y = 12, R = 5  },
                new Data { X = 4, Y = 0, R = 4  },
            };

            MinX = -1;
            MaxX = 7;
            UnitX = 2;
            MinY = -5;
            MaxY = 15;
            UnitY = 2;
        }


        private double minX;
        public double MinX
        {
            get { return minX; }
            set { minX = value; OnPropertyChagned("MinX"); }
        }

        private double maxX;
        public double MaxX
        {
            get { return maxX; }
            set { maxX = value; OnPropertyChagned("MaxX"); }
        }

        private double unitX; 
        public double UnitX
        {
            get { return unitX; }
            set { unitX = value; OnPropertyChagned("UnitX"); }
        }
        

        private double minY;
        public double MinY
        {
            get { return minY; }
            set { minY = value; OnPropertyChagned("MinY"); }
        }

        private double maxY;
        public double MaxY
        {
            get { return maxY; }
            set { maxY = value; OnPropertyChagned("MaxY"); }
        }

        private double unitY;
        public double UnitY
        {
            get { return unitY; }
            set { unitY = value; OnPropertyChagned("UnitY"); }
        }
        
        private List<Data> data;
        public List<Data> Data
        {
            get { return data; }
            set { data = value; OnPropertyChagned("Data"); }
        }

        public void ChangeData()
        {
            Data = new List<Data> 
            {
                new Data { X = 2, Y = 1, R = 3 },
                new Data { X = 4, Y = 2, R = 5  },
                new Data { X = 6, Y = 3, R = 1 },
                new Data { X = 8, Y = 4, R = 3  },
                new Data { X = 10, Y = 5, R = 1  },
            };

            MinX = 0;
            MaxX = 12;
            UnitX = 4;
            MinY = 0;
            MaxY = 6;
            UnitY = 2;
        }


        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChagned(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }

    public class Data
    {
        public double X { get; set; }
        public double Y { get; set; }
        public double R { get; set; }
    }
}
